

		org		$3300

		opt		cd
		opt		6809
;******************************************
;KILL IRQ'S
;******************************************
start

;******************************************
; SG24
;******************************************
		ldx		#$400
		ldd		#$8080
bigcls		std		,x++
		cmpx		#$1c00
		blo		bigcls	

		sta		$ffc5
		sta		$ffc3

		ldx 		#$400
		ldu		#coco
lp1		ldd		,u++
		ora		#$c0
		orb		#$c0
		std		,x++
		cmpu		#plasm
		bne		lp1


		ldx		#$1aa0

lp2		ldd		,u++
		ora		#$c0
		orb		#$c0
		std		,x++
		cmpu		#plend
		bne		lp2

;******************************************
; SCREEN POINTER
;******************************************

mainloop0
		ldx		#pl_start+16
		bra		wait_vsync
mainloop1
		ldx		#pl_start+fb_w+16

wait_vsync
wvs		lda		$ff03
		bpl		wvs
		lda		$ff02
		dec		fcount
		bne		y1loop

		jmp		$3c00

dooh		inc		$400
		bra		dooh	
;******************************************
; YLOOP
;******************************************

y1loop

t1		lda		>sintab
t2		adda		>sintab
t3		adda		>sintab

		sta		ctmod+2
ctmod		ldu		#coltab

t41		ldy		#sintab

;******************************************
; XLOOP
;******************************************
; FORCES 5 BIT OFFSETS (+/-)
;******************************************
xiter		macro
		ldd		(\1-8)*2,y	; (y=sintab)

		lda		a,u		; (u=coltab)
		ldb		b,u		; (u=coltab)
		std		(\1-8)*2,x
		endm

x1loop

		xiter		4
		xiter		5
		xiter		6
		xiter		7
		xiter		8
		xiter		9
		xiter		10
		xiter		11
		leax		2*fb_w,x	; skip line

;******************************************
; END XLOOP
;******************************************

		inc		t1+2
		inc		t2+2

		cmpx		#pl_end+16
		lblo		y1loop

;******************************************
; END YLOOP
;******************************************

		lda		t3+2
		adda		#3
		sta		t3+2

		lda		t41+3
		suba		#3
		sta		t41+3

p1p2		ldd		#$0000
		inca
		subb		#3
		std		p1p2+1
		sta		t1+2
		stb		t2+2

		cmpx		#pl_end+16
		lbeq		mainloop1

		; exit if any key pressed
		lbra		mainloop0

return
		rts


fcount		fcb		180

		rmb		(384-*%256)%256	; align with $xx80

black		equ		$80
dk_orange	equ		$20
br_orange	equ		$60
green		equ		$8f
yellow		equ		$9f
blue		equ		$af
red		equ		$bf
white		equ		$cf
cyan		equ		$df
magenta		equ		$ef
orange		equ		$ff

coltab_a	macro
		fill	black,2
		fill	dk_orange,2
		fill	red,2
		fill	orange,2
		fill	br_orange,2
		fill	yellow,2
		fill	green,2
		fill	cyan,2
		fill	green,2
		fill	yellow,2
		fill	br_orange,2
		fill	orange,2
		fill	red,2
		fill	dk_orange,2
		fill	black,2

		fill	dk_orange,2
		fill	red,2
		fill	blue,2
		fill	magenta,2
		fill	blue,2
		fill	red,2
		fill	orange,2
		fill	br_orange,2
		fill	yellow,2
		fill	green,2
		fill	cyan,2
		fill	green,2
		fill	yellow,2
		fill	br_orange,2
		fill	orange,2
		fill	red,2
		fill	dk_orange,2
		endm

coltab_b	macro
		fill	black,2
		fill	dk_orange,2
		fill	red,2
		fill	orange,2
		fill	br_orange,2
		fill	yellow,2
		fill	white,2
		fill	white,2
		fill	white,2
		fill	yellow,2
		fill	br_orange,2
		fill	orange,2
		fill	red,2
		fill	dk_orange,2

		fill	red,2
		fill	blue,2
		fill	red,2
		fill	magenta,2
		fill	blue,2
		fill	magenta,2
		fill	red,2
		fill	blue,2
		fill	red,2
		fill	orange,2
		fill	br_orange,2
		fill	yellow,2
		fill	green,2
		fill	yellow,2
		fill	br_orange,2
		fill	orange,2
		fill	red,2
		fill	dk_orange,2
		endm

		coltab_a
		coltab_b
coltab
		coltab_a
		coltab_b
		coltab_a
		coltab_b
		coltab_a
		coltab_b

		; already aligned

sintab_n	macro
		fcb	0,-1,-2,-3,-4,-5,-6,-7
		fcb	-8,-9,-10,-11,-12,-13,-14,-15
		fcb	-16,-17,-18,-19,-20,-21,-22,-22
		fcb	-23,-24,-25,-26,-27,-27,-28,-29
		fcb	-30,-30,-31,-32,-32,-33,-34,-34
		fcb	-35,-35,-36,-37,-37,-38,-38,-38
		fcb	-39,-39,-40,-40,-40,-40,-41,-41
		fcb	-41,-41,-42,-42,-42,-42,-42,-42
		fcb	-42,-42,-42,-42,-42,-42,-42,-41
		fcb	-41,-41,-41,-40,-40,-40,-40,-39
		fcb	-39,-38,-38,-38,-37,-37,-36,-35
		fcb	-35,-34,-34,-33,-32,-32,-31,-30
		fcb	-30,-29,-28,-27,-27,-26,-25,-24
		fcb	-23,-22,-22,-21,-20,-19,-18,-17
		fcb	-16,-15,-14,-13,-12,-11,-10,-9
		fcb	-8,-7,-6,-5,-4,-3,-2,-1
		endm

sintab_p	macro
		fcb	0,1,2,3,4,5,6,7
		fcb	8,9,10,11,12,13,14,15
		fcb	16,17,18,19,20,21,22,22
		fcb	23,24,25,26,27,27,28,29
		fcb	30,30,31,32,32,33,34,34
		fcb	35,35,36,37,37,38,38,38
		fcb	39,39,40,40,40,40,41,41
		fcb	41,41,42,42,42,42,42,42
		fcb	42,42,42,42,42,42,42,41
		fcb	41,41,41,40,40,40,40,39
		fcb	39,38,38,38,37,37,36,35
		fcb	35,34,34,33,32,32,31,30
		fcb	30,29,28,27,27,26,25,24
		fcb	23,22,22,21,20,19,18,17
		fcb	16,15,14,13,12,11,10,9
		fcb	8,7,6,5,4,3,2,1
		endm

		sintab_n
sintab
		sintab_p
		sintab_n
		sintab_p


fb0		equ		$0800
fb_w		equ		32
fb_h		equ		128
fb0_end		equ		fb0+fb_w*fb_h

pl_h		equ		128
pl_start	equ		fb0+((fb_h-pl_h)/2)*fb_w
pl_end		equ		pl_start+pl_h*fb_w


coco
	fcb	$c5,$cf,$cf,$ca,$c5,$cf,$cf,$ca,$c5,$cf,$cf,$ca,$c5,$cf,$cf,$ca,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0
	fcb	$c5,$cf,$cf,$ca,$c5,$cf,$cf,$ca,$c5,$cf,$cf,$ca,$c5,$cf,$cf,$ca,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0
	fcb	$c5,$c0,$c0,$ca,$c5,$c0,$c5,$ca,$c5,$c0,$c0,$ca,$c5,$c0,$c5,$ca,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0
	fcb	$c5,$c0,$c0,$ca,$c5,$c0,$c5,$ca,$c5,$c0,$c0,$ca,$c5,$c0,$c5,$ca,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0
	fcb	$c5,$ca,$c0,$c0,$c5,$c0,$c0,$ca,$c5,$ca,$c0,$c0,$c5,$c0,$c0,$ca,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0
	fcb	$c5,$ca,$c0,$c0,$c5,$c0,$c0,$ca,$c5,$ca,$c0,$c0,$c5,$c0,$c0,$ca,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0
	fcb	$c5,$ca,$c0,$ca,$c5,$c0,$c0,$ca,$c5,$ca,$c0,$ca,$c5,$c0,$c0,$ca,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0
	fcb	$c5,$cf,$cf,$ca,$c5,$cf,$cf,$ca,$c5,$cf,$cf,$ca,$c5,$cf,$cf,$ca,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0
	fcb	$c5,$cf,$cf,$ca,$c5,$cf,$cf,$ca,$c5,$cf,$cf,$ca,$c5,$cf,$cf,$ca,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0
	fcb	$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0

line1	fcb	$cf,$cf,$cf,$cf,$cf,$cf,$cf,$cf,$cf,$cf,$cf,$cf,$cf,$cf,$cf,$cf,$cf,$cf,$cf,$cf,$cf,$cf,$cf,$cf,$cf,$cf,$cf,$cf,$cf,$cf,$cf,$cf

plasm
line2	fcb	$cf,$cf,$cf,$cf,$cf,$cf,$cf,$cf,$cf,$cf,$cf,$cf,$cf,$cf,$cf,$cf,$cf,$cf,$cf,$cf,$cf,$cf,$cf,$cf,$cf,$cf,$cf,$cf,$cf,$cf,$cf,$cf
	fcb	$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0


	fcb	$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c5,$cf,$cf,$ca,$c5,$c0,$c0,$c0,$c0,$cf,$cf,$c0,$c5,$cf,$cf,$ca,$c5,$cf,$cf,$ca
	fcb	$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c5,$cf,$cf,$ca,$c5,$c0,$c0,$c0,$c0,$cf,$cf,$c0,$c5,$cf,$cf,$ca,$c5,$cf,$cf,$ca
	fcb	$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c5,$c0,$c0,$ca,$c5,$c0,$c0,$c0,$c0,$ca,$c5,$c0,$c5,$c0,$c0,$c0,$c5,$c0,$ca,$ca
	fcb	$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c5,$c0,$c0,$ca,$c5,$c0,$c0,$c0,$c0,$ca,$c5,$c0,$c5,$c0,$c0,$c0,$c5,$c0,$ca,$ca
	fcb	$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c5,$cf,$cf,$ca,$c5,$ca,$c0,$c0,$c5,$cf,$cf,$ca,$c5,$cf,$cf,$ca,$c5,$ca,$ca,$ca
	fcb	$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c5,$cf,$cf,$ca,$c5,$ca,$c0,$c0,$c5,$cf,$cf,$ca,$c5,$cf,$cf,$ca,$c5,$ca,$ca,$ca
	fcb	$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c5,$ca,$c0,$c0,$c5,$ca,$c0,$c0,$c5,$ca,$c0,$ca,$c0,$c0,$c5,$ca,$c5,$ca,$ca,$ca
	fcb	$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c5,$ca,$c0,$c0,$c5,$cf,$cf,$ca,$c5,$ca,$c0,$ca,$c5,$cf,$cf,$ca,$c5,$ca,$ca,$ca
	fcb	$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c5,$ca,$c0,$c0,$c5,$cf,$cf,$ca,$c5,$ca,$c0,$ca,$c5,$cf,$cf,$ca,$c5,$ca,$ca,$ca

plend	equ	*


		end	start
